---------------------------
-- MonkStatue, by Siweia
---------------------------
-- Config
local DefaultPoint = {"CENTER", 0, -300}
local IconSize = 32
local FadeOutAlpha = 0.3

-- Init
local _, class = UnitClass("player")
if class ~= "MONK" then return end

local CreateSD = function(f, m, s, n)
	if f.Shadow then return end
	f.Shadow = CreateFrame("Frame", nil, f, "BackdropTemplate")
	f.Shadow:SetPoint("TOPLEFT", f, -m, m)
	f.Shadow:SetPoint("BOTTOMRIGHT", f, m, -m)
	f.Shadow:SetBackdrop({
		edgeFile = "Interface\\Addons\\MonkStatue\\Media\\glowTex", edgeSize = s })
	f.Shadow:SetBackdropBorderColor(0, 0, 0, 1)
	f.Shadow:SetFrameLevel(n or f:GetFrameLevel())
	return f.Shadow
end

local CreateIF = function(f, HL)
	CreateSD(f, 3, 3)
	f.Icon = f:CreateTexture(nil, "ARTWORK")
	f.Icon:SetAllPoints()
	f.Icon:SetTexCoord(.08, .92, .08, .92)
	f.CD = CreateFrame("Cooldown", nil, f, "CooldownFrameTemplate")
	f.CD:SetAllPoints()
	f.CD:SetReverse(true)
	if HL then
		f:EnableMouse(true)
		f.HL = f:CreateTexture(nil, "HIGHLIGHT")
		f.HL:SetColorTexture(1, 1, 1, .3)
		f.HL:SetAllPoints(f.Icon)
	end
end

-- Monk Statue
local bu
local function StatueGo()
	if bu then bu:Show() return end

	bu = CreateFrame("Button", "MonkStatueIcon", UIParent, "SecureActionButtonTemplate, BackdropTemplate")
	bu:SetPoint(unpack(DefaultPoint))
	bu:SetSize(IconSize, IconSize)
	CreateIF(bu, true)
	bu:RegisterForClicks("AnyUp")
	bu:SetAttribute("type1", "macro")
	bu:SetAttribute("type2", "macro")
	bu:SetAttribute("macrotext2", "/click TotemFrameTotem1 RightButton")
	bu:SetScript("OnEnter", function(self)
		if self:GetAlpha() < 1 then return end
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:ClearLines()
		GameTooltip:SetTotem(1)
		GameTooltip:Show()
	end)
	bu:SetScript("OnLeave", GameTooltip_Hide)

	bu:SetMovable(true)
	bu:SetUserPlaced(true)
	bu:SetClampedToScreen(true)
	bu:RegisterForDrag("LeftButton")
	bu:SetScript("OnDragStart", function() bu:StartMoving() end)
	bu:SetScript("OnDragStop", function() bu:StopMovingOrSizing() end)
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_TALENT_UPDATE")
f:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_LOGIN" or event == "PLAYER_TALENT_UPDATE" then
		if (GetSpecializationInfo(GetSpecialization()) == 270 and IsPlayerSpell(115313)) or IsPlayerSpell(115315) then
			StatueGo()
			bu:SetAlpha(FadeOutAlpha)
			bu.CD:Hide()
			local statue
			if IsPlayerSpell(115313) then
				bu.Icon:SetTexture(GetSpellTexture(115313))
				statue = GetSpellInfo(115313)
			else
				bu.Icon:SetTexture(GetSpellTexture(115315))
				statue = GetSpellInfo(115315)
			end
			bu:SetAttribute("macrotext1", "/tar "..statue)
			self:RegisterEvent("PLAYER_TOTEM_UPDATE")
		else
			if bu then bu:Hide() end
			self:UnregisterEvent("PLAYER_TOTEM_UPDATE")
		end
	elseif event == "PLAYER_TOTEM_UPDATE" then
		local haveTotem, _, start, dur = GetTotemInfo(1)
		if haveTotem then
			bu.CD:SetCooldown(start, dur)
			bu.CD:Show()
			bu:SetAlpha(1)
		else
			bu.CD:Hide()
			bu:SetAlpha(FadeOutAlpha)
		end
	end
end)